/**
 * POCDMT000040Reference.java
 *
 * File generated from the cdaepsos3::POCDMT000040Reference uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.cdaepsos3;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;
import org.w3c.dom.Document;
import org.w3c.dom.Node;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.*;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import java.util.ArrayList;
import java.util.List;

// End of user code


/**
 * Description of the class POCDMT000040Reference.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "POCD_MT000040.Reference", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"seperatableInd",
	"externalAct",
	"externalObservation",
	"externalProcedure",
	"externalDocument",
	"nullFlavor",
	"typeCode"
})
@XmlRootElement(name = "POCD_MT000040.Reference")
public class POCDMT000040Reference implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CS> realmCode;
	@XmlElement(name = "typeId", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos3.POCDMT000040InfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.II> templateId;
	@XmlElement(name = "seperatableInd", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.BL seperatableInd;
	@XmlElement(name = "externalAct", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos3.POCDMT000040ExternalAct externalAct;
	@XmlElement(name = "externalObservation", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos3.POCDMT000040ExternalObservation externalObservation;
	@XmlElement(name = "externalProcedure", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos3.POCDMT000040ExternalProcedure externalProcedure;
	@XmlElement(name = "externalDocument", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cdaepsos3.POCDMT000040ExternalDocument externalDocument;
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.voc.NullFlavor nullFlavor;
	@XmlAttribute(name = "typeCode", required = true)
	public net.ihe.gazelle.voc.XActRelationshipExternalReference typeCode;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<net.ihe.gazelle.datatypes.CS> getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<net.ihe.gazelle.datatypes.CS>();
	    }
	    return realmCode;
	}
	
	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<net.ihe.gazelle.datatypes.CS> realmCode) {
	    this.realmCode = realmCode;
	}
	
	
	
	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().add(realmCode_elt);
	}
	
	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.getRealmCode().remove(realmCode_elt);
	}
	
	/**
	 * Return typeId.
	 * @return typeId
	 */
	public net.ihe.gazelle.cdaepsos3.POCDMT000040InfrastructureRootTypeId getTypeId() {
	    return typeId;
	}
	
	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(net.ihe.gazelle.cdaepsos3.POCDMT000040InfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}
	
	
	
	
	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.datatypes.II> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.datatypes.II>();
	    }
	    return templateId;
	}
	
	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.datatypes.II> templateId) {
	    this.templateId = templateId;
	}
	
	
	
	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().add(templateId_elt);
	}
	
	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.getTemplateId().remove(templateId_elt);
	}
	
	/**
	 * Return seperatableInd.
	 * @return seperatableInd
	 */
	public net.ihe.gazelle.datatypes.BL getSeperatableInd() {
	    return seperatableInd;
	}
	
	/**
	 * Set a value to attribute seperatableInd.
	 * @param seperatableInd.
	 */
	public void setSeperatableInd(net.ihe.gazelle.datatypes.BL seperatableInd) {
	    this.seperatableInd = seperatableInd;
	}
	
	
	
	
	/**
	 * Return externalAct.
	 * @return externalAct
	 */
	public net.ihe.gazelle.cdaepsos3.POCDMT000040ExternalAct getExternalAct() {
	    return externalAct;
	}
	
	/**
	 * Set a value to attribute externalAct.
	 * @param externalAct.
	 */
	public void setExternalAct(net.ihe.gazelle.cdaepsos3.POCDMT000040ExternalAct externalAct) {
	    this.externalAct = externalAct;
	}
	
	
	
	
	/**
	 * Return externalObservation.
	 * @return externalObservation
	 */
	public net.ihe.gazelle.cdaepsos3.POCDMT000040ExternalObservation getExternalObservation() {
	    return externalObservation;
	}
	
	/**
	 * Set a value to attribute externalObservation.
	 * @param externalObservation.
	 */
	public void setExternalObservation(net.ihe.gazelle.cdaepsos3.POCDMT000040ExternalObservation externalObservation) {
	    this.externalObservation = externalObservation;
	}
	
	
	
	
	/**
	 * Return externalProcedure.
	 * @return externalProcedure
	 */
	public net.ihe.gazelle.cdaepsos3.POCDMT000040ExternalProcedure getExternalProcedure() {
	    return externalProcedure;
	}
	
	/**
	 * Set a value to attribute externalProcedure.
	 * @param externalProcedure.
	 */
	public void setExternalProcedure(net.ihe.gazelle.cdaepsos3.POCDMT000040ExternalProcedure externalProcedure) {
	    this.externalProcedure = externalProcedure;
	}
	
	
	
	
	/**
	 * Return externalDocument.
	 * @return externalDocument
	 */
	public net.ihe.gazelle.cdaepsos3.POCDMT000040ExternalDocument getExternalDocument() {
	    return externalDocument;
	}
	
	/**
	 * Set a value to attribute externalDocument.
	 * @param externalDocument.
	 */
	public void setExternalDocument(net.ihe.gazelle.cdaepsos3.POCDMT000040ExternalDocument externalDocument) {
	    this.externalDocument = externalDocument;
	}
	
	
	
	
	/**
	 * Return nullFlavor.
	 * @return nullFlavor
	 */
	public net.ihe.gazelle.voc.NullFlavor getNullFlavor() {
	    return nullFlavor;
	}
	
	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor.
	 */
	public void setNullFlavor(net.ihe.gazelle.voc.NullFlavor nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}
	
	
	
	
	/**
	 * Return typeCode.
	 * @return typeCode
	 */
	public net.ihe.gazelle.voc.XActRelationshipExternalReference getTypeCode() {
	    return typeCode;
	}
	
	/**
	 * Set a value to attribute typeCode.
	 * @param typeCode.
	 */
	public void setTypeCode(net.ihe.gazelle.voc.XActRelationshipExternalReference typeCode) {
	    this.typeCode = typeCode;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.cdaepsos3");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "POCD_MT000040.Reference").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(POCDMT000040Reference pOCDMT000040Reference, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (pOCDMT000040Reference != null){
   			cvm.validate(pOCDMT000040Reference, _location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CS realmCode: pOCDMT000040Reference.getRealmCode()){
					net.ihe.gazelle.datatypes.CS.validateByModule(realmCode, _location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.cdaepsos3.POCDMT000040InfrastructureRootTypeId.validateByModule(pOCDMT000040Reference.getTypeId(), _location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.II templateId: pOCDMT000040Reference.getTemplateId()){
					net.ihe.gazelle.datatypes.II.validateByModule(templateId, _location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.datatypes.BL.validateByModule(pOCDMT000040Reference.getSeperatableInd(), _location + "/seperatableInd", cvm, diagnostic);
			net.ihe.gazelle.cdaepsos3.POCDMT000040ExternalAct.validateByModule(pOCDMT000040Reference.getExternalAct(), _location + "/externalAct", cvm, diagnostic);
			net.ihe.gazelle.cdaepsos3.POCDMT000040ExternalObservation.validateByModule(pOCDMT000040Reference.getExternalObservation(), _location + "/externalObservation", cvm, diagnostic);
			net.ihe.gazelle.cdaepsos3.POCDMT000040ExternalProcedure.validateByModule(pOCDMT000040Reference.getExternalProcedure(), _location + "/externalProcedure", cvm, diagnostic);
			net.ihe.gazelle.cdaepsos3.POCDMT000040ExternalDocument.validateByModule(pOCDMT000040Reference.getExternalDocument(), _location + "/externalDocument", cvm, diagnostic);
    	}
    }

}